<!doctype html>
<html>
<head>
    <title>Tor 0.3.1.7 is now released! | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor 0.3.1.7 is now released! | Tor Project">
    <meta property="og:description" content="There&#39;s a new stable Tor release series available! After months of work, you can now download the source code for Tor 0.3.1.7 from the usual place on the website. Packages should become available over the coming days, including (we hope) a Tor Browser release before the end of the month. Tor 0.3.1.7 is the first stable release in the 0.3.1 series.">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-0317-now-released/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor 0.3.1.7 is now released!
      </h1>
    <p class="meta">by nickm | September 18, 2017</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>There's a new stable Tor release series available!  After months of work, you can now download the source code for Tor 0.3.1.7 from the usual place on the website. Packages should become available over the coming days, including (we hope) a Tor Browser release before the end of the month.</p>
<p>Tor 0.3.1.7 is the first stable release in the 0.3.1 series.</p>
<p>With the 0.3.1 series, Tor now serves and downloads directory information in more compact formats, to save on bandwidth overhead. It also contains a new padding system to resist netflow-based traffic analysis, and experimental support for building parts of Tor in Rust (though no parts of Tor are in Rust yet). There are also numerous small features, bugfixes on earlier release series, and groundwork for the onion services revamp of 0.3.2.</p>
<p>This release also includes a fix for TROVE-2017-008, a security bug that affects onion services running with the SafeLogging option disabled. For more information, see <a href="https://trac.torproject.org/projects/tor/ticket/23490">https://trac.torproject.org/projects/tor/ticket/23490</a></p>
<p>Per our stable release policy, we plan to support each stable release series for at least the next nine months, or for three months after the first stable release of the next series: whichever is longer. If you need a release with long-term support, we recommend that you stay with the 0.2.9 series.</p>
<p>Below is a list of the changes since 0.3.0. For a list of all changes since 0.3.1.6-rc, see the ChangeLog file.</p>
<h2>Changes in version 0.3.1.7 - 2017-09-18</h2>
<ul>
<li>New dependencies:
<ul>
<li>To build with zstd and lzma support, Tor now requires the pkg-config tool at build time.</li>
</ul>
</li>
<li>Major bugfixes (security, onion services, loggging):
<ul>
<li>Fix a bug where we could log uninitialized stack when a certain onion service error occurred while SafeLogging was disabled. Fixes bug #23490; bugfix on 0.2.7.2-alpha. This is also tracked as TROVE-2017-008 and CVE-2017-0380.</li>
</ul>
</li>
</ul>
<!--break--><ul>
<li>Major features (build system, continuous integration):
<ul>
<li>Tor's repository now includes a Travis Continuous Integration (CI) configuration file (.travis.yml). This is meant to help new developers and contributors who fork Tor to a Github repository be better able to test their changes, and understand what we expect to pass. To use this new build feature, you must fork Tor to your Github account, then go into the "Integrations" menu in the repository settings for your fork and enable Travis, then push your changes. Closes ticket <a href="https://bugs.torproject.org/22636">22636</a>.</li>
</ul>
</li>
<li>Major features (directory protocol):
<ul>
<li>Tor relays and authorities can now serve clients an abbreviated version of the consensus document, containing only the changes since an older consensus document that the client holds. Clients now request these documents when available. When both client and server use this new protocol, they will use far less bandwidth (up to 94% less) to keep the client's consensus up-to-date. Implements proposal 140; closes ticket <a href="https://bugs.torproject.org/13339">13339</a>. Based on work by Daniel Martí.</li>
<li>Tor can now compress directory traffic with lzma or with zstd compression algorithms, which can deliver better bandwidth performance. Because lzma is computationally expensive, it's only used for documents that can be compressed once and served many times. Support for these algorithms requires that tor is built with the libzstd and/or liblzma libraries available. Implements proposal 278; closes ticket <a href="https://bugs.torproject.org/21662">21662</a>.</li>
<li>Relays now perform the more expensive compression operations, and consensus diff generation, in worker threads. This separation avoids delaying the main thread when a new consensus arrives.</li>
</ul>
</li>
<li>Major features (experimental):
<ul>
<li>Tor can now build modules written in Rust. To turn this on, pass the "--enable-rust" flag to the configure script. It's not time to get excited yet: currently, there is no actual Rust functionality beyond some simple glue code, and a notice at startup to tell you that Rust is running. Still, we hope that programmers and packagers will try building Tor with Rust support, so that we can find issues and solve portability problems. Closes ticket <a href="https://bugs.torproject.org/22106">22106</a>.</li>
</ul>
</li>
<li>Major features (traffic analysis resistance):
<ul>
<li>
<p>Connections between clients and relays now send a padding cell in each direction every 1.5 to 9.5 seconds (tunable via consensus parameters). This padding will not resist specialized eavesdroppers, but it should be enough to make many ISPs' routine network flow logging less useful in traffic analysis against Tor users.</p>
<p>Padding is negotiated using Tor's link protocol, so both relays and clients must upgrade for this to take effect. Clients may still send padding despite the relay's version by setting ConnectionPadding 1 in torrc, and may disable padding by setting ConnectionPadding 0 in torrc. Padding may be minimized for mobile users with the torrc option ReducedConnectionPadding. Implements Proposal 251 and Section 2 of Proposal 254; closes ticket <a href="https://bugs.torproject.org/16861">16861</a>.</p>
</li>
<li>Relays will publish 24 hour totals of padding and non-padding cell counts to their extra-info descriptors, unless PaddingStatistics 0 is set in torrc. These 24 hour totals are also rounded to multiples of 10000.</li>
</ul>
</li>
<li>Major bugfixes (onion service, relay, security):
<ul>
<li>Fix a remotely triggerable assertion failure when a onion service handles a malformed BEGIN cell. Fixes bug <a href="https://bugs.torproject.org/22493">22493</a>, tracked as TROVE-2017-004 and as CVE-2017-0375; bugfix on 0.3.0.1-alpha.</li>
<li>Fix a remotely triggerable assertion failure caused by receiving a BEGIN_DIR cell on a onion service rendezvous circuit. Fixes bug <a href="https://bugs.torproject.org/22494">22494</a>, tracked as TROVE-2017-005 and CVE-2017-0376; bugfix on 0.2.2.1-alpha.</li>
</ul>
</li>
<li>Major bugfixes (path selection, security):
<ul>
<li>When choosing which guard to use for a circuit, avoid the exit's family along with the exit itself. Previously, the new guard selection logic avoided the exit, but did not consider its family. Fixes bug <a href="https://bugs.torproject.org/22753">22753</a>; bugfix on 0.3.0.1-alpha. Tracked as TROVE-2017- 006 and CVE-2017-0377.</li>
</ul>
</li>
<li>Major bugfixes (connection usage):
<ul>
<li>We use NETINFO cells to try to determine if both relays involved in a connection will agree on the canonical status of that connection. We prefer the connections where this is the case for extend cells, and try to close connections where relays disagree on their canonical status early. Also, we now prefer the oldest valid connection for extend cells. These two changes should reduce the number of long-term connections that are kept open between relays. Fixes bug <a href="https://bugs.torproject.org/17604">17604</a>; bugfix on 0.2.5.5-alpha.</li>
<li>Relays now log hourly statistics (look for "channel_check_for_duplicates" lines) on the total number of connections to other relays. If the number of connections per relay is unexpectedly large, this log message is at notice level. Otherwise it is at info.</li>
</ul>
</li>
<li>Major bugfixes (entry guards):
<ul>
<li>When starting with an old consensus, do not add new entry guards unless the consensus is "reasonably live" (under 1 day old). Fixes one root cause of bug <a href="https://bugs.torproject.org/22400">22400</a>; bugfix on 0.3.0.1-alpha.</li>
<li>Don't block bootstrapping when a primary bridge is offline and we can't get its descriptor. Fixes bug <a href="https://bugs.torproject.org/22325">22325</a>; fixes one case of bug <a href="https://bugs.torproject.org/21969">21969</a>; bugfix on 0.3.0.3-alpha.</li>
</ul>
</li>
<li>Major bugfixes (linux TPROXY support):
<ul>
<li>Fix a typo that had prevented TPROXY-based transparent proxying from working under Linux. Fixes bug <a href="https://bugs.torproject.org/18100">18100</a>; bugfix on 0.2.6.3-alpha. Patch from "d4fq0fQAgoJ".</li>
</ul>
</li>
<li>Major bugfixes (openbsd, denial-of-service):
<ul>
<li>Avoid an assertion failure bug affecting our implementation of inet_pton(AF_INET6) on certain OpenBSD systems whose strtol() handling of "0xx" differs from what we had expected. Fixes bug <a href="https://bugs.torproject.org/22789">22789</a>; bugfix on 0.2.3.8-alpha. Also tracked as TROVE-2017-007.</li>
</ul>
</li>
<li>Major bugfixes (relay, link handshake):
<ul>
<li>When performing the v3 link handshake on a TLS connection, report that we have the x509 certificate that we actually used on that connection, even if we have changed certificates since that connection was first opened. Previously, we would claim to have used our most recent x509 link certificate, which would sometimes make the link handshake fail. Fixes one case of bug <a href="https://bugs.torproject.org/22460">22460</a>; bugfix on 0.2.3.6-alpha.</li>
</ul>
</li>
<li>Major bugfixes (relays, key management):
<ul>
<li>Regenerate link and authentication certificates whenever the key that signs them changes; also, regenerate link certificates whenever the signed key changes. Previously, these processes were only weakly coupled, and we relays could (for minutes to hours) wind up with an inconsistent set of keys and certificates, which other relays would not accept. Fixes two cases of bug <a href="https://bugs.torproject.org/22460">22460</a>; bugfix on 0.3.0.1-alpha.</li>
<li>When sending an Ed25519 signing-&gt;link certificate in a CERTS cell, send the certificate that matches the x509 certificate that we used on the TLS connection. Previously, there was a race condition if the TLS context rotated after we began the TLS handshake but before we sent the CERTS cell. Fixes a case of bug <a href="https://bugs.torproject.org/22460">22460</a>; bugfix on 0.3.0.1-alpha.</li>
</ul>
</li>
<li>Minor features (security, windows):
<ul>
<li>Enable a couple of pieces of Windows hardening: one (HeapEnableTerminationOnCorruption) that has been on-by-default since Windows 8, and unavailable before Windows 7; and one (PROCESS_DEP_DISABLE_ATL_THUNK_EMULATION) which we believe doesn't affect us, but shouldn't do any harm. Closes ticket <a href="https://bugs.torproject.org/21953">21953</a>.</li>
</ul>
</li>
<li>Minor features (bridge authority):
<ul>
<li>Add "fingerprint" lines to the networkstatus-bridges file produced by bridge authorities. Closes ticket <a href="https://bugs.torproject.org/22207">22207</a>.</li>
</ul>
</li>
<li>Minor features (code style):
<ul>
<li>Add "Falls through" comments to our codebase, in order to silence GCC 7's -Wimplicit-fallthrough warnings. Patch from Andreas Stieger. Closes ticket <a href="https://bugs.torproject.org/22446">22446</a>.</li>
</ul>
</li>
<li>Minor features (config options):
<ul>
<li>Allow "%include" directives in torrc configuration files. These directives import the settings from other files, or from all the files in a directory. Closes ticket <a href="https://bugs.torproject.org/1922">1922</a>. Code by Daniel Pinto.</li>
<li>Make SAVECONF return an error when overwriting a torrc that has includes. Using SAVECONF with the FORCE option will allow it to overwrite torrc even if includes are used. Related to ticket <a href="https://bugs.torproject.org/1922">1922</a>.</li>
<li>Add "GETINFO config-can-saveconf" to tell controllers if SAVECONF will work without the FORCE option. Related to ticket <a href="https://bugs.torproject.org/1922">1922</a>.</li>
</ul>
</li>
<li>Minor features (controller):
<ul>
<li>Warn the first time that a controller requests data in the long- deprecated 'GETINFO network-status' format. Closes ticket <a href="https://bugs.torproject.org/21703">21703</a>.</li>
</ul>
</li>
<li>Minor features (defaults):
<ul>
<li>The default value for UseCreateFast is now 0: clients which haven't yet received a consensus document will now use a proper ntor handshake to talk to their directory servers whenever they can. Closes ticket <a href="https://bugs.torproject.org/21407">21407</a>.</li>
<li>Onion key rotation and expiry intervals are now defined as a network consensus parameter, per proposal 274. The default lifetime of an onion key is increased from 7 to 28 days. Old onion keys will expire after 7 days by default. This change will make consensus diffs much smaller, and save significant bandwidth. Closes ticket <a href="https://bugs.torproject.org/21641">21641</a>.</li>
</ul>
</li>
<li>Minor features (defensive programming):
<ul>
<li>Create a pair of consensus parameters, nf_pad_tor2web and nf_pad_single_onion, to disable netflow padding in the consensus for non-anonymous connections in case the overhead is high. Closes ticket <a href="https://bugs.torproject.org/17857">17857</a>.</li>
</ul>
</li>
<li>Minor features (diagnostic):
<ul>
<li>Add a stack trace to the bug warnings that can be logged when trying to send an outgoing relay cell with n_chan == 0. Diagnostic attempt for bug <a href="https://bugs.torproject.org/23105">23105</a>.</li>
<li>Add logging messages to try to diagnose a rare bug that seems to generate RSA-&gt;Ed25519 cross-certificates dated in the 1970s. We think this is happening because of incorrect system clocks, but we'd like to know for certain. Diagnostic for bug <a href="https://bugs.torproject.org/22466">22466</a>.</li>
<li>Avoid an assertion failure, and log a better error message, when unable to remove a file from the consensus cache on Windows. Attempts to mitigate and diagnose bug <a href="https://bugs.torproject.org/22752">22752</a>.</li>
</ul>
</li>
<li>Minor features (directory authority):
<ul>
<li>Improve the message that authorities report to relays that present RSA/Ed25519 keypairs that conflict with previously pinned keys. Closes ticket <a href="https://bugs.torproject.org/22348">22348</a>.</li>
</ul>
</li>
<li>Minor features (directory cache, consensus diff):
<ul>
<li>Add a new MaxConsensusAgeForDiffs option to allow directory cache operators with low-resource environments to adjust the number of consensuses they'll store and generate diffs from. Most cache operators should leave it unchanged. Helps to work around bug <a href="https://bugs.torproject.org/22883">22883</a>.</li>
</ul>
</li>
<li>Minor features (fallback directory list):
<ul>
<li>Update the fallback directory mirror whitelist and blacklist based on operator emails. Closes task 21121.</li>
<li>Replace the 177 fallbacks originally introduced in Tor 0.2.9.8 in December 2016 (of which ~126 were still functional) with a list of 151 fallbacks (32 new, 119 unchanged, 58 removed) generated in May 2017. Resolves ticket <a href="https://bugs.torproject.org/21564">21564</a>.</li>
</ul>
</li>
<li>Minor features (geoip):
<ul>
<li>Update geoip and geoip6 to the September 6 2017 Maxmind GeoLite2 Country database.</li>
</ul>
</li>
<li>Minor features (onion services, logging):
<ul>
<li>Log a message when an onion service descriptor has fewer introduction points than specified in HiddenServiceNumIntroductionPoints. Closes tickets 21598.</li>
<li>Log a message when an onion service reaches its introduction point circuit limit, and when that limit is reset. Follow up to ticket <a href="https://bugs.torproject.org/21594">21594</a>; closes ticket <a href="https://bugs.torproject.org/21622">21622</a>.</li>
<li>Warn user if multiple entries in EntryNodes and at least one HiddenService are used together. Pinning EntryNodes along with an onion service can be possibly harmful; for instance see ticket <a href="https://bugs.torproject.org/14917">14917</a> or 21155. Closes ticket <a href="https://bugs.torproject.org/21155">21155</a>.</li>
</ul>
</li>
<li>Minor features (linux seccomp2 sandbox):
<ul>
<li>We now have a document storage backend compatible with the Linux seccomp2 sandbox. This backend is used for consensus documents and diffs between them; in the long term, we'd like to use it for unparseable directory material too. Closes ticket <a href="https://bugs.torproject.org/21645">21645</a></li>
<li>Increase the maximum allowed size passed to mprotect(PROT_WRITE) from 1MB to 16MB. This was necessary with the glibc allocator in order to allow worker threads to allocate more memory -- which in turn is necessary because of our new use of worker threads for compression. Closes ticket <a href="https://bugs.torproject.org/22096">22096</a>.</li>
</ul>
</li>
<li>Minor features (logging):
<ul>
<li>Log files are no longer created world-readable by default. (Previously, most distributors would store the logs in a non- world-readable location to prevent inappropriate access. This change is an extra precaution.) Closes ticket <a href="https://bugs.torproject.org/21729">21729</a>; patch from toralf.</li>
</ul>
</li>
<li>Minor features (performance):
<ul>
<li>Our Keccak (SHA-3) implementation now accesses memory more efficiently, especially on little-endian systems. Closes ticket <a href="https://bugs.torproject.org/21737">21737</a>.</li>
<li>Add an O(1) implementation of channel_find_by_global_id(), to speed some controller functions.</li>
</ul>
</li>
<li>Minor features (relay, configuration):
<ul>
<li>The MyFamily option may now be repeated as many times as desired, for relays that want to configure large families. Closes ticket <a href="https://bugs.torproject.org/4998">4998</a>; patch by Daniel Pinto.</li>
</ul>
</li>
<li>Minor features (relay, performance):
<ul>
<li>Always start relays with at least two worker threads, to prevent priority inversion on slow tasks. Part of the fix for bug <a href="https://bugs.torproject.org/22883">22883</a>.</li>
<li>Allow background work to be queued with different priorities, so that a big pile of slow low-priority jobs will not starve out higher priority jobs. This lays the groundwork for a fix for bug <a href="https://bugs.torproject.org/22883">22883</a>.</li>
</ul>
</li>
<li>Minor features (safety):
<ul>
<li>Add an explicit check to extrainfo_parse_entry_from_string() for NULL inputs. We don't believe this can actually happen, but it may help silence a warning from the Clang analyzer. Closes ticket <a href="https://bugs.torproject.org/21496">21496</a>.</li>
</ul>
</li>
<li>Minor features (testing):
<ul>
<li>Add more tests for compression backend initialization. Closes ticket <a href="https://bugs.torproject.org/22286">22286</a>.</li>
<li>Add a "--disable-memory-sentinels" feature to help with fuzzing. When Tor is compiled with this option, we disable a number of redundant memory-safety failsafes that are intended to stop bugs from becoming security issues. This makes it easier to hunt for bugs that would be security issues without the failsafes turned on. Closes ticket <a href="https://bugs.torproject.org/21439">21439</a>.</li>
<li>Add a general event-tracing instrumentation support to Tor. This subsystem will enable developers and researchers to add fine- grained instrumentation to their Tor instances, for use when examining Tor network performance issues. There are no trace events yet, and event-tracing is off by default unless enabled at compile time. Implements ticket <a href="https://bugs.torproject.org/13802">13802</a>.</li>
<li>Improve our version parsing tests: add tests for typical version components, add tests for invalid versions, including numeric range and non-numeric prefixes. Unit tests 21278, 21450, and 21507. Partially implements 21470.</li>
</ul>
</li>
<li>Minor bugfixes (bandwidth accounting):
<ul>
<li>Roll over monthly accounting at the configured hour and minute, rather than always at 00:00. Fixes bug <a href="https://bugs.torproject.org/22245">22245</a>; bugfix on 0.0.9rc1. Found by Andrey Karpov with PVS-Studio.</li>
</ul>
</li>
<li>Minor bugfixes (code correctness):
<ul>
<li>Accurately identify client connections by their lack of peer authentication. This means that we bail out earlier if asked to extend to a client. Follow-up to 21407. Fixes bug <a href="https://bugs.torproject.org/21406">21406</a>; bugfix on 0.2.4.23.</li>
</ul>
</li>
<li>Minor bugfixes (compilation warnings):
<ul>
<li>Suppress -Wdouble-promotion warnings with clang 4.0. Fixes bug <a href="https://bugs.torproject.org/22915">22915</a>; bugfix on 0.2.8.1-alpha.</li>
<li>Fix warnings when building with libscrypt and openssl scrypt support on Clang. Fixes bug <a href="https://bugs.torproject.org/22916">22916</a>; bugfix on 0.2.7.2-alpha.</li>
<li>When building with certain versions of the mingw C header files, avoid float-conversion warnings when calling the C functions isfinite(), isnan(), and signbit(). Fixes bug <a href="https://bugs.torproject.org/22801">22801</a>; bugfix on 0.2.8.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (compilation):
<ul>
<li>Avoid compiler warnings in the unit tests for calling tor_sscanf() with wide string outputs. Fixes bug <a href="https://bugs.torproject.org/15582">15582</a>; bugfix on 0.2.6.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (compression):
<ul>
<li>When spooling compressed data to an output buffer, don't try to spool more data when there is no more data to spool and we are not trying to flush the input. Previously, we would sometimes launch compression requests with nothing to do, which interferes with our 22672 checks. Fixes bug <a href="https://bugs.torproject.org/22719">22719</a>; bugfix on 0.2.0.16-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (configuration):
<ul>
<li>Do not crash when starting with LearnCircuitBuildTimeout 0. Fixes bug <a href="https://bugs.torproject.org/22252">22252</a>; bugfix on 0.2.9.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (connection lifespan):
<ul>
<li>Allow more control over how long TLS connections are kept open: unify CircuitIdleTimeout and PredictedPortsRelevanceTime into a single option called CircuitsAvailableTimeout. Also, allow the consensus to control the default values for both this preference and the lifespan of relay-to-relay connections. Fixes bug <a href="https://bugs.torproject.org/17592">17592</a>; bugfix on 0.2.5.5-alpha.</li>
<li>Increase the initial circuit build timeout testing frequency, to help ensure that ReducedConnectionPadding clients finish learning a timeout before their orconn would expire. The initial testing rate was set back in the days of TAP and before the Tor Browser updater, when we had to be much more careful about new clients making lots of circuits. With this change, a circuit build timeout is learned in about 15-20 minutes, instead of 100-120 minutes.</li>
</ul>
</li>
<li>Minor bugfixes (controller):
<ul>
<li>Do not crash when receiving a HSPOST command with an empty body. Fixes part of bug <a href="https://bugs.torproject.org/22644">22644</a>; bugfix on 0.2.7.1-alpha.</li>
<li>Do not crash when receiving a POSTDESCRIPTOR command with an empty body. Fixes part of bug <a href="https://bugs.torproject.org/22644">22644</a>; bugfix on 0.2.0.1-alpha.</li>
<li>GETINFO onions/current and onions/detached no longer respond with 551 on empty lists. Fixes bug <a href="https://bugs.torproject.org/21329">21329</a>; bugfix on 0.2.7.1-alpha.</li>
<li>Trigger HS descriptor events on the control port when the client fails to pick an onion service directory for an onion service. This can happen if all the hidden service directories are in ExcludeNodes, or they have all been queried within the last 15 minutes. Fixes bug <a href="https://bugs.torproject.org/22042">22042</a>; bugfix on 0.2.5.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (correctness):
<ul>
<li>Avoid undefined behavior when parsing IPv6 entries from the geoip6 file. Fixes bug <a href="https://bugs.torproject.org/22490">22490</a>; bugfix on 0.2.4.6-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (coverity build support):
<ul>
<li>Avoid Coverity build warnings related to our BUG() macro. By default, Coverity treats BUG() as the Linux kernel does: an instant abort(). We need to override that so our BUG() macro doesn't prevent Coverity from analyzing functions that use it. Fixes bug <a href="https://bugs.torproject.org/23030">23030</a>; bugfix on 0.2.9.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (defensive programming):
<ul>
<li>Detect and break out of infinite loops in our compression code. We don't think that any such loops exist now, but it's best to be safe. Closes ticket <a href="https://bugs.torproject.org/22672">22672</a>.</li>
<li>Fix a memset() off the end of an array when packing cells. This bug should be harmless in practice, since the corrupted bytes are still in the same structure, and are always padding bytes, ignored, or immediately overwritten, depending on compiler behavior. Nevertheless, because the memset()'s purpose is to make sure that any other cell-handling bugs can't expose bytes to the network, we need to fix it. Fixes bug <a href="https://bugs.torproject.org/22737">22737</a>; bugfix on 0.2.4.11-alpha. Fixes CID 1401591.</li>
</ul>
</li>
<li>Minor bugfixes (directory authority):
<ul>
<li>When a directory authority rejects a descriptor or extrainfo with a given digest, mark that digest as undownloadable, so that we do not attempt to download it again over and over. We previously tried to avoid downloading such descriptors by other means, but we didn't notice if we accidentally downloaded one anyway. This behavior became problematic in 0.2.7.2-alpha, when authorities began pinning Ed25519 keys. Fixes bug <a href="https://bugs.torproject.org/22349">22349</a>; bugfix on 0.2.1.19-alpha.</li>
<li>When rejecting a router descriptor for running an obsolete version of Tor without ntor support, warn about the obsolete tor version, not the missing ntor key. Fixes bug <a href="https://bugs.torproject.org/20270">20270</a>; bugfix on 0.2.9.3-alpha.</li>
<li>Prevent the shared randomness subsystem from asserting when initialized by a bridge authority with an incomplete configuration file. Fixes bug <a href="https://bugs.torproject.org/21586">21586</a>; bugfix on 0.2.9.8.</li>
</ul>
</li>
<li>Minor bugfixes (error reporting, windows):
<ul>
<li>When formatting Windows error messages, use the English format to avoid codepage issues. Fixes bug <a href="https://bugs.torproject.org/22520">22520</a>; bugfix on 0.1.2.8-alpha. Patch from "Vort".</li>
</ul>
</li>
<li>Minor bugfixes (exit-side DNS):
<ul>
<li>Fix an untriggerable assertion that checked the output of a libevent DNS error, so that the assertion actually behaves as expected. Fixes bug <a href="https://bugs.torproject.org/22244">22244</a>; bugfix on 0.2.0.20-rc. Found by Andrey Karpov using PVS-Studio.</li>
</ul>
</li>
<li>Minor bugfixes (fallback directories):
<ul>
<li>Make the usage example in updateFallbackDirs.py actually work, and explain what it does. Fixes bug <a href="https://bugs.torproject.org/22270">22270</a>; bugfix on 0.3.0.3-alpha.</li>
<li>Decrease the guard flag average required to be a fallback. This allows us to keep relays that have their guard flag removed when they restart. Fixes bug <a href="https://bugs.torproject.org/20913">20913</a>; bugfix on 0.2.8.1-alpha.</li>
<li>Decrease the minimum number of fallbacks to 100. Fixes bug <a href="https://bugs.torproject.org/20913">20913</a>; bugfix on 0.2.8.1-alpha.</li>
<li>Make sure fallback directory mirrors have the same address, port, and relay identity key for at least 30 days before they are selected. Fixes bug <a href="https://bugs.torproject.org/20913">20913</a>; bugfix on 0.2.8.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (file limits, osx):
<ul>
<li>When setting the maximum number of connections allowed by the OS, always allow some extra file descriptors for other files. Fixes bug <a href="https://bugs.torproject.org/22797">22797</a>; bugfix on 0.2.0.10-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (onion services):
<ul>
<li>Increase the number of circuits that a service is allowed to open over a specific period of time. The value was lower than it should be (8 vs 12) in the normal case of 3 introduction points. Fixes bug <a href="https://bugs.torproject.org/22159">22159</a>; bugfix on 0.3.0.5-rc.</li>
<li>Fix a BUG warning during HSv3 descriptor decoding that could be cause by a specially crafted descriptor. Fixes bug <a href="https://bugs.torproject.org/23233">23233</a>; bugfix on 0.3.0.1-alpha. Bug found by "haxxpop".</li>
<li>Stop printing a cryptic warning when an onion service gets a request to connect to a virtual port that it hasn't configured. Fixes bug <a href="https://bugs.torproject.org/16706">16706</a>; bugfix on 0.2.6.3-alpha.</li>
<li>Simplify onion service descriptor creation by using an existing flag to check if an introduction point is established. Fixes bug <a href="https://bugs.torproject.org/21599">21599</a>; bugfix on 0.2.7.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (link handshake):
<ul>
<li>Lower the lifetime of the RSA-&gt;Ed25519 cross-certificate to six months, and regenerate it when it is within one month of expiring. Previously, we had generated this certificate at startup with a ten-year lifetime, but that could lead to weird behavior when Tor was started with a grossly inaccurate clock. Mitigates bug <a href="https://bugs.torproject.org/22466">22466</a>; mitigation on 0.3.0.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (linux seccomp2 sandbox):
<ul>
<li>Avoid a sandbox failure when trying to re-bind to a socket and mark it as IPv6-only. Fixes bug <a href="https://bugs.torproject.org/20247">20247</a>; bugfix on 0.2.5.1-alpha.</li>
<li>Permit the fchmod system call, to avoid crashing on startup when starting with the seccomp2 sandbox and an unexpected set of permissions on the data directory or its contents. Fixes bug <a href="https://bugs.torproject.org/22516">22516</a>; bugfix on 0.2.5.4-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (logging):
<ul>
<li>When decompressing, do not warn if we fail to decompress using a compression method that we merely guessed. Fixes part of bug <a href="https://bugs.torproject.org/22670">22670</a>; bugfix on 0.1.1.14-alpha.</li>
<li>When decompressing, treat mismatch between content-encoding and actual compression type as a protocol warning. Fixes part of bug <a href="https://bugs.torproject.org/22670">22670</a>; bugfix on 0.1.1.9-alpha.</li>
<li>Downgrade "assigned_to_cpuworker failed" message to info-level severity. In every case that can reach it, either a better warning has already been logged, or no warning is warranted. Fixes bug <a href="https://bugs.torproject.org/22356">22356</a>; bugfix on 0.2.6.3-alpha.</li>
<li>Log a better message when a directory authority replies to an upload with an unexpected status code. Fixes bug <a href="https://bugs.torproject.org/11121">11121</a>; bugfix on 0.1.0.1-rc.</li>
<li>Downgrade a log statement about unexpected relay cells from "bug" to "protocol warning", because there is at least one use case where it can be triggered by a buggy tor implementation. Fixes bug <a href="https://bugs.torproject.org/21293">21293</a>; bugfix on 0.1.1.14-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (logging, relay):
<ul>
<li>Remove a forgotten debugging message when an introduction point successfully establishes an onion service prop224 circuit with a client.</li>
<li>Change three other log_warn() for an introduction point to protocol warnings, because they can be failure from the network and are not relevant to the operator. Fixes bug <a href="https://bugs.torproject.org/23078">23078</a>; bugfix on 0.3.0.1-alpha and 0.3.0.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (relay):
<ul>
<li>Inform the geoip and rephist modules about all requests, even on relays that are only fetching microdescriptors. Fixes a bug related to 21585; bugfix on 0.3.0.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (memory leaks):
<ul>
<li>Fix a small memory leak at exit from the backtrace handler code. Fixes bug <a href="https://bugs.torproject.org/21788">21788</a>; bugfix on 0.2.5.2-alpha. Patch from Daniel Pinto.</li>
<li>When directory authorities reject a router descriptor due to keypinning, free the router descriptor rather than leaking the memory. Fixes bug <a href="https://bugs.torproject.org/22370">22370</a>; bugfix on 0.2.7.2-alpha.</li>
<li>Fix a small memory leak when validating a configuration that uses two or more AF_UNIX sockets for the same port type. Fixes bug <a href="https://bugs.torproject.org/23053">23053</a>; bugfix on 0.2.6.3-alpha. This is CID 1415725.</li>
</ul>
</li>
<li>Minor bugfixes (process behavior):
<ul>
<li>When exiting because of an error, always exit with a nonzero exit status. Previously, we would fail to report an error in our exit status in cases related to __OwningControllerProcess failure, lockfile contention, and Ed25519 key initialization. Fixes bug <a href="https://bugs.torproject.org/22720">22720</a>; bugfix on versions 0.2.1.6-alpha, 0.2.2.28-beta, and 0.2.7.2-alpha respectively. Reported by "f55jwk4f"; patch from "huyvq".</li>
</ul>
</li>
<li>Minor bugfixes (robustness, error handling):
<ul>
<li>Improve our handling of the cases where OpenSSL encounters a memory error while encoding keys and certificates. We haven't observed these errors in the wild, but if they do happen, we now detect and respond better. Fixes bug <a href="https://bugs.torproject.org/19418">19418</a>; bugfix on all versions of Tor. Reported by Guido Vranken.</li>
</ul>
</li>
<li>Minor bugfixes (testing):
<ul>
<li>Fix an undersized buffer in test-memwipe.c. Fixes bug <a href="https://bugs.torproject.org/23291">23291</a>; bugfix on 0.2.7.2-alpha. Found and patched by Ties Stuij.</li>
<li>Use unbuffered I/O for utility functions around the process_handle_t type. This fixes unit test failures reported on OpenBSD and FreeBSD. Fixes bug <a href="https://bugs.torproject.org/21654">21654</a>; bugfix on 0.2.3.1-alpha.</li>
<li>Make display of captured unit test log messages consistent. Fixes bug <a href="https://bugs.torproject.org/21510">21510</a>; bugfix on 0.2.9.3-alpha.</li>
<li>Make test-network.sh always call chutney's test-network.sh. Previously, this only worked on systems which had bash installed, due to some bash-specific code in the script. Fixes bug <a href="https://bugs.torproject.org/19699">19699</a>; bugfix on 0.3.0.4-rc. Follow-up to ticket <a href="https://bugs.torproject.org/21581">21581</a>.</li>
<li>Fix a memory leak in the link-handshake/certs_ok_ed25519 test. Fixes bug <a href="https://bugs.torproject.org/22803">22803</a>; bugfix on 0.3.0.1-alpha.</li>
<li>The unit tests now pass on systems where localhost is misconfigured to some IPv4 address other than 127.0.0.1. Fixes bug <a href="https://bugs.torproject.org/6298">6298</a>; bugfix on 0.0.9pre2.</li>
</ul>
</li>
<li>Minor bugfixes (voting consistency):
<ul>
<li>Reject version numbers with non-numeric prefixes (such as +, -, or whitespace). Disallowing whitespace prevents differential version parsing between POSIX-based and Windows platforms. Fixes bug <a href="https://bugs.torproject.org/21507">21507</a> and part of 21508; bugfix on 0.0.8pre1.</li>
</ul>
</li>
<li>Minor bugfixes (Windows service):
<ul>
<li>When running as a Windows service, set the ID of the main thread correctly. Failure to do so made us fail to send log messages to the controller in 0.2.1.16-rc, slowed down controller event delivery in 0.2.7.3-rc and later, and crash with an assertion failure in 0.3.1.1-alpha. Fixes bug <a href="https://bugs.torproject.org/23081">23081</a>; bugfix on 0.2.1.6-alpha. Patch and diagnosis from "Vort".</li>
</ul>
</li>
<li>Minor bugfixes (windows, relay):
<ul>
<li>Resolve "Failure from drain_fd: No error" warnings on Windows relays. Fixes bug <a href="https://bugs.torproject.org/21540">21540</a>; bugfix on 0.2.6.3-alpha.</li>
</ul>
</li>
<li>Code simplification and refactoring:
<ul>
<li>Break up the 630-line function connection_dir_client_reached_eof() into a dozen smaller functions. This change should help maintainability and readability of the client directory code.</li>
<li>Isolate our use of the openssl headers so that they are only included from our crypto wrapper modules, and from tests that examine those modules' internals. Closes ticket <a href="https://bugs.torproject.org/21841">21841</a>.</li>
<li>Simplify our API to launch directory requests, making it more extensible and less error-prone. Now it's easier to add extra headers to directory requests. Closes ticket <a href="https://bugs.torproject.org/21646">21646</a>.</li>
<li>Our base64 decoding functions no longer overestimate the output space that they need when parsing unpadded inputs. Closes ticket <a href="https://bugs.torproject.org/17868">17868</a>.</li>
<li>Remove unused "ROUTER_ADDED_NOTIFY_GENERATOR" internal value. Resolves ticket <a href="https://bugs.torproject.org/22213">22213</a>.</li>
<li>The logic that directory caches use to spool request to clients, serving them one part at a time so as not to allocate too much memory, has been refactored for consistency. Previously there was a separate spooling implementation per type of spoolable data. Now there is one common spooling implementation, with extensible data types. Closes ticket <a href="https://bugs.torproject.org/21651">21651</a>.</li>
<li>Tor's compression module now supports multiple backends. Part of the implementation for proposal 278; closes ticket <a href="https://bugs.torproject.org/21663">21663</a>.</li>
</ul>
</li>
<li>Documentation:
<ul>
<li>Add a manpage description for the key-pinning-journal file. Closes ticket <a href="https://bugs.torproject.org/22347">22347</a>.</li>
<li>Correctly note that bandwidth accounting values are stored in the state file, and the bw_accounting file is now obsolete. Closes ticket <a href="https://bugs.torproject.org/16082">16082</a>.</li>
<li>Document more of the files in the Tor data directory, including cached-extrainfo, secret_onion_key{,_ntor}.old, hidserv-stats, approved-routers, sr-random, and diff-cache. Found while fixing ticket <a href="https://bugs.torproject.org/22347">22347</a>.</li>
<li>Clarify the manpage for the (deprecated) torify script. Closes ticket <a href="https://bugs.torproject.org/6892">6892</a>.</li>
<li>Clarify the behavior of the KeepAliveIsolateSOCKSAuth sub-option. Closes ticket <a href="https://bugs.torproject.org/21873">21873</a>.</li>
<li>Correct documentation about the default DataDirectory value. Closes ticket <a href="https://bugs.torproject.org/21151">21151</a>.</li>
<li>Document the default behavior of NumEntryGuards and NumDirectoryGuards correctly. Fixes bug <a href="https://bugs.torproject.org/21715">21715</a>; bugfix on 0.3.0.1-alpha.</li>
<li>Document key=value pluggable transport arguments for Bridge lines in torrc. Fixes bug <a href="https://bugs.torproject.org/20341">20341</a>; bugfix on 0.2.5.1-alpha.</li>
<li>Note that bandwidth-limiting options don't affect TCP headers or DNS. Closes ticket <a href="https://bugs.torproject.org/17170">17170</a>.</li>
</ul>
</li>
<li>Removed features (configuration options, all in ticket 22060):
<ul>
<li>These configuration options are now marked Obsolete, and no longer have any effect: AllowInvalidNodes, AllowSingleHopCircuits, AllowSingleHopExits, ExcludeSingleHopRelays, FastFirstHopPK, TLSECGroup, WarnUnsafeSocks. They were first marked as deprecated in 0.2.9.2-alpha and have now been removed. The previous default behavior is now always chosen; the previous (less secure) non- default behavior is now unavailable.</li>
<li>CloseHSClientCircuitsImmediatelyOnTimeout and CloseHSServiceRendCircuitsImmediatelyOnTimeout were deprecated in 0.2.9.2-alpha and now have been removed. HS circuits never close on circuit build timeout; they have a longer timeout period.</li>
<li>{Control,DNS,Dir,Socks,Trans,NATD,OR}ListenAddress were deprecated in 0.2.9.2-alpha and now have been removed. Use the ORPort option (and others) to configure listen-only and advertise-only addresses.</li>
</ul>
</li>
<li>Removed features (tools):
<ul>
<li>We've removed the tor-checkkey tool from src/tools. Long ago, we used it to help people detect RSA keys that were generated by versions of Debian affected by CVE-2008-0166. But those keys have been out of circulation for ages, and this tool is no longer required. Closes ticket <a href="https://bugs.torproject.org/21842">21842</a>.</li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-271392"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-271392" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 18, 2017</p>
    </div>
    <a href="#comment-271392">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-271392" class="permalink" rel="bookmark">Thanks for posting changelog…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thanks for posting changelog(s)!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-271402"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-271402" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 18, 2017</p>
    </div>
    <a href="#comment-271402">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-271402" class="permalink" rel="bookmark">&gt; and we relays could (for…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>&gt; and we relays could (for minutes to hours) wind up<br />
strange wording</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-271403"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-271403" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 18, 2017</p>
    </div>
    <a href="#comment-271403">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-271403" class="permalink" rel="bookmark">&gt; and unavailable before…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>&gt; and unavailable before Windows 7<br />
Huh? Available since XP SP3.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-271447"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-271447" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Patrick Durusau (not verified)</span> said:</p>
      <p class="date-time">September 22, 2017</p>
    </div>
    <a href="#comment-271447">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-271447" class="permalink" rel="bookmark">Shouldn&#039;t &quot;usual place on…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Shouldn't "usual place on the website" be a hyperlink to: <a href="https://gitweb.torproject.org/tor.git" rel="nofollow">https://gitweb.torproject.org/tor.git</a> ?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-271494"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-271494" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">September 28, 2017</p>
    </div>
    <a href="#comment-271494">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-271494" class="permalink" rel="bookmark">!…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>!<br />
TTB 7.0.6 in<br />
<a href="https://dist.torproject.org/torbrowser/7.0.6/" rel="nofollow">https://dist.torproject.org/torbrowser/7.0.6/</a> .</p>
<p>TTB 7.0.5 in<br />
<a href="https://www.torproject.org/download/download-easy.html.en" rel="nofollow">https://www.torproject.org/download/download-easy.html.en</a> .</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-271532"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-271532" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  gk
  </article>
    <div class="comment-header">
      <p class="comment__submitted">gk said:</p>
      <p class="date-time">September 29, 2017</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-271494" class="permalink" rel="bookmark">!…</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-271532">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-271532" class="permalink" rel="bookmark">Yes, that&#039;s nothing unusual…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Yes, that's nothing unusual. We need to have all the bundles in place first before updating the website pointing to it.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-271569"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-271569" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>010169 (not verified)</span> said:</p>
      <p class="date-time">September 29, 2017</p>
    </div>
    <a href="#comment-271569">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-271569" class="permalink" rel="bookmark">Is TOR browser designed for…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Is TOR browser designed for iOS on a tablet?<br />
I see OS X is listed, will it work on both?    Thanks.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
